/**
 * Copyright 2006-8 Simon Andrews
 *
 *    This file is part of ChIPMonk.
 *
 *    ChIPMonk is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    ChIPMonk is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with ChIPMonk; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package uk.ac.bbsrc.babraham.ChipMonk.DataTypes;

import uk.ac.bbsrc.babraham.ChipMonk.ChipMonkException;

public class Probe implements Comparable {

	private String name;
	private Chromosome chromosome;
	private int position;
	
	public Probe (String name, Chromosome chromosome, int position) throws ChipMonkException {
		if (chromosome != null && (position > chromosome.length() || position < 1)) {
			chromosome = null;
			position = 0;
			
//			throw new ChipMonkException("Probe "+name+" has position "+"("+position+") outside the bounds of chromosome "+chromosome.name());
		}
		this.name = new String(name);
		this.chromosome = chromosome;
		this.position = position;
	}
	
	public String name () {
		return name;
	}
	
	public Chromosome chromosome () {
		return chromosome;
	}
	
	public int position () {
		return position;
	}

	public int compareTo(Object p2) {
		return new Integer(position).compareTo(new Integer(((Probe)p2).position()));
	}
	
	public String toString () {
		return name;
	}
}
